--
-- hoseConnector
-- Specialization for hoseConnector
--
-- @author upsidedown
-- @date  01.08.2013


hoseConnector = {};

function hoseConnector.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function hoseConnector:load(xmlFile)
	

	self.hoseConnectorTargetNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.hoseConnector#targetNode"));
	self.hoseConnectorReady = false;
	
	self.hoseConnectorHUDselect = 1;
	self.hoseConnectorHUDTimeOut = 0; --0
	self.hoseConnectorHUD = {};
	
	local x, y = getScreenModeInfo(getScreenMode())
		local aspectRatio = x / y
	local hudFactor = 0.95;
	
	local path = Utils.getFilename("tatra/FB_Befuellung_moeglich.dds", self.baseDirectory);
	self.hoseConnectorHUD[1] = Overlay:new("hudReady", path, g_currentMission.fruitSymbolX, g_currentMission.fruitSymbolY-0.05, g_currentMission.fruitSymbolSize*hudFactor, g_currentMission.fruitSymbolSize * aspectRatio*hudFactor); 
	path = Utils.getFilename("tatra/FB_Befuellung_laeuft.dds", self.baseDirectory);
	self.hoseConnectorHUD[2] = Overlay:new("hudActive", path, g_currentMission.fruitSymbolX, g_currentMission.fruitSymbolY-0.05, g_currentMission.fruitSymbolSize*hudFactor, g_currentMission.fruitSymbolSize * aspectRatio*hudFactor); 
	path = Utils.getFilename("tatra/FB_Kontakt.dds", self.baseDirectory);
	self.hoseConnectorHUD[3] = Overlay:new("hudActive2", path, g_currentMission.fruitSymbolX, g_currentMission.fruitSymbolY-0.05, g_currentMission.fruitSymbolSize*hudFactor, g_currentMission.fruitSymbolSize * aspectRatio*hudFactor); 
	path = Utils.getFilename("tatra/FB_Befuellkreislauf.dds", self.baseDirectory);
	self.hoseConnectorHUD[4] = Overlay:new("hudActive3", path, g_currentMission.fruitSymbolX, g_currentMission.fruitSymbolY-0.05, g_currentMission.fruitSymbolSize*hudFactor, g_currentMission.fruitSymbolSize * aspectRatio*hudFactor); 
	
	self.hoseConnectorHUDBlinkTimer = 0
	self.hoseConnectorHUDBlinkTimerDirection = 1.0
end;

function hoseConnector:update(dt)
		
end;

function hoseConnector:updateTick(dt)

	self.hoseConnectorHUDBlinkTimer = self.hoseConnectorHUDBlinkTimer + self.hoseConnectorHUDBlinkTimerDirection*dt;
	
	if self.hoseConnectorHUDBlinkTimer > 750 then
		self.hoseConnectorHUDBlinkTimerDirection = -1.0;
	elseif self.hoseConnectorHUDBlinkTimer < 0 then
		self.hoseConnectorHUDBlinkTimerDirection = 1.0;
	end;

	self.hoseConnectorHUDTimeOut = math.max(self.hoseConnectorHUDTimeOut-dt,0);

	self.hoseConnectorPlayerInRange = false;
	if g_currentMission.controlledVehicle == nil then --player on foot
		if g_currentMission.player ~= nil then
			local pvx, pvy, pvz = getWorldTranslation(g_currentMission.player.rootNode);
			local x, y, z = getWorldTranslation(self.hoseConnectorTargetNode);
			local farmerDistance = Utils.vector3Length(pvx-x, pvy-y, pvz-z);
			
			if farmerDistance < 3  then
				self.hoseConnectorPlayerInRange = true;
			end;
		end;
	end;	
	
	

	self.hoseConnectorReady = true;--deactivated with true!
	if self.attacherVehicle == nil and self.animParts[1].toMax then
		self.hoseConnectorReady = true;
	end;
	if self.attacherVehicle ~= nil then
		if self.attacherVehicle.lastSpeed ~= nil then
			if self.attacherVehicle.lastSpeed*3600 < 12 then
				if self.animParts[1].toMax then
					self.hoseConnectorReady = true;
				end;
			end
		else
			if self.animParts[1].toMax then
				self.hoseConnectorReady = true;
			end;
		end;
	end;
end;

function hoseConnector:delete()
end;

function hoseConnector:mouseEvent(posX, posY, isDown, isUp, button)
end;

function hoseConnector:keyEvent(unicode, sym, modifier, isDown)
end;

function hoseConnector:draw()
	if self.hoseConnectorHUDTimeOut > 0 then
		if self.hoseConnectorHUDselect == 4 then
			self.hoseConnectorHUD[2]:render();
			if self.hoseConnectorHUDBlinkTimerDirection > 0 then
				self.hoseConnectorHUD[4]:render();
			end;
		else
			self.hoseConnectorHUD[self.hoseConnectorHUDselect]:render();
		end;
	end;
end;

function hoseConnector:onAttach()
end; 	

function hoseConnector:onDetach()
end;